Loading...
Searching...
No Matches
ConnectionProvider::AbstractConnectionWithInfo Class Referenceabstract

abstract base class for connections More...

`#include <AbstractConnectionWithInfo.qc.dox.h>`

Inheritance diagram for ConnectionProvider::AbstractConnectionWithInfo:
[legend]

## Public Member Functions

| constructor (string name, string description, string url, hash< auto > attributes={}, hash< auto > options={})
| creates the AbstractConnection object More...
hash< ConnectionSchemeInfo > | getConnectionSchemeInfo ()
| Returns the ConnectionSchemeInfo hash for this object.
*hash< auto > | getDefaultOptions ()
| returns default options
*hash< auto > | getOptions ()
| returns static / initialization options
Public Member Functions inherited from ConnectionProvider::AbstractConnection
deprecated | constructor (string name, string desc, string url, bool monitor, *hash opts, hash urlh, *string safe_url, *bool enabled)
| creates the AbstractConnection object More...
| constructor (string name, string description, string url, hash< auto > attributes={}, hash< auto > options={})
| creates the AbstractConnection object More...
object | get (bool connect=True, *hash< auto > rtopts)
| returns the underlying connection object More...
hash< ConfigInfo > | getConfigHash ()
| returns a ConfigInfo hash of static configuration information about the connection More...
hash< ConnectionSchemeInfo > | getConnectionSchemeInfo ()
| Returns a default ConnectionSchemeInfo hash.
AbstractDataProvider | getDataProvider ()
| returns a data provider object for this connection, if supported More...
*hash< auto > | getDefaultOptions ()
| returns default options
string | getDescription ()
| Returns the connection description. More...
hash< auto > | getExtendedInfo (*hash< auto > opts)
| Returns connection info plus any extended information returned by the connection. More...
hash< ConnectionInfo > | getInfo (*hash< auto > opts)
| returns a ConnectionInfo hash of information about the connection More...
hash< ConnectionInfo > | getInfo (bool with_password=False)
| returns a ConnectionInfo hash of information about the connection More...
string | getName ()
| Returns the connection name. More...
*hash< auto > | getOptions ()
| returns static / initialization options
object | getPollImpl ()
| Returns an unconnected object for a non-blocking poll operation. More...
*hash< auto > | getRealOptions ()
| returns options for saving the connection's configuration information
*hash< auto > | getRuntimeOptions ()
| returns runtime options
string | getSafeUrl ()
| Returns the connection safe URL (without password info) More...
auto | getTag (string tag)
| returns the value of the given tag or NOTHING if not present
auto | getTagEx (string tag)
| returns the value of the given tag or throws an exception if the tag is not set with a value More...
hash< auto > | getTags ()
| returns all tags associated with the connection
abstract string | getType ()
| returns the string type name for the connection object
string | getUrl ()
| Returns the connection URL. More...
bool | hasDataProvider ()
| returns True if the connection returns a data provider with the getDataProvider() method More...
| parseTextOptions ()
| this method is called when parsing connection file definitions from text files when loading into the database More...
hash< PingInfo > | ping (bool throw_exception=False)
| returns a hash with the results of the ping operation More...
AbstractPollOperation | startPollConnect ()
| Called to start the connection polling operation. More...
bool | supportsPollingApi ()
| returns True if the connection supports the Qore Socket-based polling API More...

## Protected Member Functions

abstract hash< ConnectionSchemeInfo > | getConnectionSchemeInfoImpl ()
| Returns the ConnectionSchemeInfo hash for this object.
Protected Member Functions inherited from ConnectionProvider::AbstractConnection
abstract object | getImpl (bool connect=True, *hash< auto > rtopts)
| this method must return the connection object corresponding to the object's configuration More...
string | getSafeUrl (hash< auto > urlh)
| creates a "safe" URL string with password information removed More...
hash< UrlInfo > | parseUrl (string url)
| Parse the URL to a hash. More...
hash< PingInfo > | pingIntern (hash< PingInfo > rv)
| performs the ping by executing get(); returns a PingInfo hash
| setChildCapabilitiesImpl ()
| Override to set child data provider capabilities once per child class.
hash< auto > | validateOptions (hash< auto > options)
| performs options validation in the constructor More...

## Additional Inherited Members

Public Attributes inherited from ConnectionProvider::AbstractConnection
bool | children_can_support_apis = False
| if the data provider or any of its children support requests (APIs)
bool | children_can_support_messages = False
| if the data provider or any of its children support messages
bool | children_can_support_observers = False
| if the data provider or any of its children support events
bool | children_can_support_records = False
| if the data provider or any of its children support records
bool | debug_data = False
| debug data flag; to be used an an indication for a higher-level implementation
string | desc
| connection description
bool | enabled = True
| enabled/disabled indicator flag
hash< auto > | internal_info
| internal tags
date | last_check
| date/time of last check/ping
bool | locked = False
| locked/unlocked flag
bool | loopback = False
| set to True for loopback connections
bool | monitor
| monitoring flag
string | name
| connection name
*hash< auto > | opts
| connection options
*hash< auto > | orig_opts
| original connection options
string | safe_url
| "safe" URL (password information removed)
string | status = "not checked"
| status string; in case of a connection error this string will be the error string
hash< auto > | tags = {}
| connection tags; user-defined key-value pairs
bool | up = False
| connection status flag; set by monitoring or explicit pings/connections
date | updated
| date/time of last update
string | url
| connection URL (potentially with password info)
hash< auto > | urlh
| broken down URL hash (as returned by Qore::parse_url())
Static Public Attributes inherited from ConnectionProvider::AbstractConnection
static *code | post_processing
| optional code for default post-processing of objects created by getImpl(); must take the connection object and the object created as arguments

## Detailed Description

abstract base class for connections

this class can be specialized to provide for user-defined connection types

## Member Function Documentation

## constructor()

ConnectionProvider::AbstractConnectionWithInfo::constructor | ( | string | name,
|  | string | description,
|  | string | url,
|  | hash< auto > | attributes = `{}`,
|  | hash< auto > | options = `{}`
| ) |  |

creates the AbstractConnection object

Parameters

  name | the name of the connection
  description | connection description
  url | connection URL (potentially with password info)
  attributes | various attributes; see below
  options | connection options

Attributes
  Attributes are special flags for given connection - stored as public attributes of the object instance. For now there are:
  - `enabled` (bool), default `True`
  - `monitor` (bool), default `True`
  - `locked` (bool), default `False`
  - `tags` (hash), no default value

Exceptions

  CONNECTION-OPTION-ERROR | missing or invalid connection option